# Systems are given the following arguments: component hash, eid integer

module CES
	class SystemReference
		@@systems = {}
		
		def self.register(component_name, &block)
			@@systems[component_name] = block
		end
		def self.unregister(component_name)
			@@systems[component_name]
		end
		def self.systems
			return @@systems
		end
		
		def self.tick(time = 0, ticks = 1)
			ticks.times {
				#cached_entity_list = CES::Entity.entity_list
				
				@@systems.each { |system_name, system_block|
					CES::ComponentReference.components[system_name]["entities"].each { |entity|
						system_block.call(CES::ComponentReference.components[system_name]["component"], entity)
					}
				}
				
				#cached_entity_list = nil
				sleep time
			}
		end
		def self.run(time = 1)
			loop {
				tick(time)
			}
		end
	end
end